
-- This function determines which digits are valid choices for the given cell

function checkSquare (r,c)

	FinalAnswer = {}
	
	if isaClue[r][c] == 0 then
		for candidate = 1,9 do
			legalchoice = true
			
			-- check row
			for cc = 1, 9 do
				if (c ~= cc) and (guess[r][cc] == candidate) then
					legalchoice = false
					break
				end
			end
		
			-- check column
			for rr = 1, 9 do
				if (r ~= rr) and (guess[rr][c] == candidate) then
					legalchoice = false
					break
				end
			end
			
			
			-- check box
			boxX = math.floor ( (r-1) / 3) *3 + 1
			boxY = math.floor ( (c-1) / 3) *3 + 1
			for cc=boxY,boxY+2 do
					for rr=boxX,boxX+2 do
						if (c ~= cc) and (r ~= rr) and (guess[rr][cc] == candidate) then
							legalchoice = false
							break
						end
					
					end
			end
			
			if legalchoice == true then
				table.insert(FinalAnswer, candidate)
			end
		
		end
	end

	return FinalAnswer

end


function doDrawPossibleChoices()

	
	function list_iter (t)
		local i = 0
		local n = table.getn(t)
		return function ()
		i = i + 1
		if i <= n then return t[i] end
		end
	end


	local tb = {}
	tb = checkSquare(selX,selY)

	
	candidates = table.getn(tb)
	if candidates > 0 then  -- if no candidates then it was probably a "Clue" cell
		if candidates == 1 then
			aStr = "Probably "  -- just having some fun here...  :)
		elseif candidates == 2 then
			aStr = "Either "
		elseif candidates == 3 then
			aStr = "Could be "
		elseif candidates == 4 then
			aStr = "Pick "
		else
			aStr = "Guess!  "
		end
		
		for element in list_iter(tb) do
			aStr = aStr .. element .. ","
		end
		
		aStr = string.sub(aStr, 1, -2) -- chop off last char
		TimerFont:print(aStr, infoCenterX,infoCenterY+5, BitFont.CENTER, white)
		
		
		-- Truetype has been disabled for now
		-- screen:fontPrint(testfont, infoCenterX+5,infoCenterY+10, aStr, white)
	end

end


-- Check to see if the puzzle is finished.  This will be improved later...  :)
-- Right now it just checks if there is one occurence of every digit in columns and rows

function checkForSolution()
	for i=1,9 do
		seen1={0,0,0,0,0,0,0,0,0}
		seen2={0,0,0,0,0,0,0,0,0}
		for j=1,9 do
			if guess[i][j]~=0 then
				if seen1[guess[i][j]]==0 then
					seen1[guess[i][j]]=1
				else
					return false
				end
			else
				return false
			end
			if guess[j][i]~=0 then
				if seen2[guess[j][i]]==0 then
					seen2[guess[j][i]]=1
				else
					return false
				end
			else
				return false
			end
		end
	end
	return true
end
